; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_FM_RDS_INITIALISIERUNG:
	rcall RDS_CLEAR


	ldi temp1,LOW (FM_RDS_INT_SOURCE)		;Property Low Byte			
	ldi temp2,HIGH(FM_RDS_INT_SOURCE)		;Property High Byte			
	ldi temp3,0b00000001					;Property Value Low Byte	
	ldi temp4,0b00000000					;Property Value High Byte	
	rcall SI4735_SET_PROPERTY_TEMP1_4

	ldi temp1,LOW (FM_RDS_INT_FIFO_COUNT)	;Property Low Byte			
	ldi temp2,HIGH(FM_RDS_INT_FIFO_COUNT)	;Property High Byte			
	ldi temp3,LOW (1)						;Property Value Low Byte	
	ldi temp4,HIGH(1)						;Property Value High Byte	
	rcall SI4735_SET_PROPERTY_TEMP1_4

	ldi temp1,LOW (FM_RDS_CONFIG)			;Property Low Byte			
	ldi temp2,HIGH(FM_RDS_CONFIG)			;Property High Byte			
	ldi temp3,0x01 ;RDSEN				;Property Value Low Byte		
	ldi temp4,0b10101010;(Block Error Threshold BLOCKA...C)	;Property Value High Byte	
	rcall SI4735_SET_PROPERTY_TEMP1_4

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_CLEAR:
	STS(adr_RDS_PI_L),NULL
	STS(adr_RDS_PI_H),NULL

	STS(adr_RDS_PTY),NULL
	STS(adr_RDS_TP),NULL
	STS(adr_RDS_TA),NULL
	STS(adr_RDS_MS),NULL

	STS(adr_RDS_ZEIT_HH),NULL
	STS(adr_RDS_ZEIT_MM),NULL
	STS(adr_RDS_ZEIT_OFFSET),NULL

	; SCHLEIFE (8)		
	ldi ZL, LOW (adr_RDS_BEREICH_SENDERNAME)
	ldi ZH, HIGH(adr_RDS_BEREICH_SENDERNAME)
	ldi temp1,8
	ldi temp,'_'
RDS_CLEAR_w1:
	ST z+,temp
	dec temp1
	brne RDS_CLEAR_w1
	; SCHLEIFE (128)	
	ldi ZL, LOW (adr_RDS_BEREICH_RADIOTEXT)
	ldi ZH, HIGH(adr_RDS_BEREICH_RADIOTEXT)
	ldi temp1,128
	ldi temp,'_'
RDS_CLEAR_w2:
	ST z+,temp
	dec temp1
	brne RDS_CLEAR_w2
	; SCHLEIFE (32)		
	ldi ZL, LOW (adr_RDS_BEREICH_GRUPPENNUMMERN)
	ldi ZH, HIGH(adr_RDS_BEREICH_GRUPPENNUMMERN)
	ldi temp1,32
	clr temp
RDS_CLEAR_w3:
	ST z+,temp
	dec temp1
	brne RDS_CLEAR_w3

	; SCHLEIFE (256)	
	ldi ZL, LOW (adr_RDS_BEREICH_AF)
	ldi ZH, HIGH(adr_RDS_BEREICH_AF)
	clr temp1
	clr temp
RDS_CLEAR_w4:
	ST z+,temp
	dec temp1
	brne RDS_CLEAR_w4


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bit 	D7 	D6 	D5 	D4 	D3 	D2 			D1 		D0		
; CMD 	0 	0 	1 	0 	0 	1 			0 		0		
; ARG1 	0 	0 	0 	0 	0 	STATUSONLY 	MTFIFO 	INTACK	
;														
; ARG1 2 STATUSONLY Status Only. Determines if data should be removed from the RDS FIFO.0 = Data in BLOCKA, BLOCKB, BLOCKC, BLOCKD, and BLE contain the oldestdata in the RDS FIFO.1 = Data in BLOCKA will contain the last valid block A data received for the current station. Data in BLOCKB will contain the last valid block B data received for the current station. Data in BLE will describe the bit errors for the data in BLOCKA and BLOCKB.
; ARG1 1 MTFIFO Empty FIFO 0 = If FIFO not empty, read and remove oldest FIFO entry. 1 = Clear RDS Receive FIFO.	
; ARG1 0 INTACKInterrupt Acknowledge0 = RDSINT status preserved.1 = Clears RDSINT.									
;																													
; Response																											
; Bit 		D7 	D6 	D5 				D4 				D3 		D2 				D1 			D0							
; STATUS 	CTS ERR X 				X 				RSQINT 	RDSINT 			X 			STCINT						
; RESP1 	X 	X 	RDSNEWBLOCKB 	RDSNEWBLOCKA 	X 		RDSSYNCFOUND 	RDSSYNCLOST RDSRECV						
; RESP2 	X 	X 	X 				X 				X 		GRPLOST 		X 			RDSSYNC						
; RESP3 RDSFIFOUSED[7:0]	
; RESP4 BLOCKA[15:8]		
; RESP5 BLOCKA[7:0]			
; RESP6 BLOCKB[15:8]		
; RESP7 BLOCKB[7:0]			
; RESP8 BLOCKC[15:8]		
; RESP9 BLOCKC[7:0]			
; RESP10 BLOCKD[15:8]		
; RESP11 BLOCKD[7:0]		
; RESP12 BLEA[1:0] BLEB[1:0] BLEC[1:0] BLED[1:0]
SI4735_FM_RDS_STATUS:

	rcall SI4735_GET_INT_STATUS
	LDS temp,(adr_STATUS)
	andi temp,(STATUS_BIT_RDSINT)	; BIT herausfiltern	
	tst temp
	brne SI4735_FM_RDS_STATUS_ACTION
	ret
;-------------------------------------------------------------------------------
SI4735_FM_RDS_STATUS_ACTION:
	; Status abfragen		
	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; MT-START	
	ldi temp1,(FM_RDS_STATUS)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; CMD		
	ldi temp1,0x00000001	; 	STATUSONLY,MTFIFO,INTACK	
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG		
	rcall TWI_STOP								; STOPP		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_RECEIVER_START_TEMP1		; MR-START	
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; STATUS	
	STS(adr_STATUS),temp1
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP1		
	STS(adr_RESP_01),temp1
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP2		
	STS(adr_RESP_02),temp1
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP3		
	STS(adr_RESP_03),temp1; RDS FIFO Used
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP4		
	STS(adr_RDS_BLOCK_AH),temp1	; BLOCK-AH
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP5		
	STS(adr_RDS_BLOCK_AL),temp1	; BLOCK-AL
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP6		
	STS(adr_RDS_BLOCK_BH),temp1	; BLOCK-BH
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP7		
	STS(adr_RDS_BLOCK_BL),temp1	; BLOCK-BL
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP8		
	STS(adr_RDS_BLOCK_CH),temp1	; BLOCK-CH
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP9		
	STS(adr_RDS_BLOCK_CL),temp1	; BLOCK-CL
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP10	
	STS(adr_RDS_BLOCK_DH),temp1	; BLOCK-DH
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP11	
	STS(adr_RDS_BLOCK_DL),temp1	; BLOCK-DL
	rcall TWI_MASTER_RECEIVER_NO_ACK_TEMP1		; RESP12	
	STS(adr_RESP_12),temp1	; RDS-ERROR	
	STS(adr_RDS_ERROR),temp1
	rcall TWI_STOP								; STOPP		

	rcall RDS_AUSWERTUNG

	LDS temp,(adr_RESP_03); RDS FIFO Used
	cpi temp,1
	breq SI4735_FM_RDS_STATUS_FERTIG
	brlo SI4735_FM_RDS_STATUS_FERTIG
	rjmp SI4735_FM_RDS_STATUS_ACTION

SI4735_FM_RDS_STATUS_FERTIG:


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_AUSWERTUNG:
	; ERROR			
	LDS temp,(adr_RDS_ERROR)
	tst temp
	brne RDS_AUSWERTUNG_ERROR
	; NULL BLOCK-A
	LDS temp,(adr_RDS_BLOCK_AH)
	tst temp
	breq RDS_AUSWERTUNG_ERROR
	; NULL BLOCK-A
	LDS temp,(adr_RDS_BLOCK_AL)
	tst temp
	breq RDS_AUSWERTUNG_ERROR
	rjmp RDS_AUSWERTUNG_GRUPPENTYP
;-------------------------------------------------------------------------------
RDS_AUSWERTUNG_ERROR:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	rcall wait_1ms
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_AUSWERTUNG_GRUPPENTYP:
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	rcall wait_1ms
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
;-------------------------------------------------------------------------------
	; RS232			
	rcall RS232_DATA_OUT
	; PI (wird in allen Gruppen gesendet)		
	LDS temp,(adr_RDS_BLOCK_AH)
	STS(adr_RDS_PI_H),temp	; im SRAM ablegen	
	LDS temp,(adr_RDS_BLOCK_AL)
	STS(adr_RDS_PI_L),temp	; im SRAM ablegen	
	; TP (wird in allen Gruppen gesendet)		
	LDS temp,(adr_RDS_BLOCK_BH)
	andi temp,0b00000100	; Bitmuster			
	STS(adr_RDS_TP),temp	; im SRAM ablegen	
	; PTY (wird in allen Gruppen gesendet)		
	LDS temp1,(adr_RDS_BLOCK_BH)
	LDS temp, (adr_RDS_BLOCK_BL)
	LSR temp1	; 5 mal rechts
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	andi temp,0b00011111	; Bitmuster	
	STS(adr_RDS_PTY),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; GT (Gruppentyp) filtern		
	LDS temp,(adr_RDS_BLOCK_BH)
	LSR temp	; 3 mal rechts
	LSR temp	; 
	LSR temp	; 
	STS(adr_RDS_GT),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; GT fr Anzeige speichern		
	LDS temp,(adr_RDS_GT)
	; Z initialisieren	
	ldi ZL,LOW (adr_RDS_BEREICH_GRUPPENNUMMERN)
	ldi ZH,HIGH(adr_RDS_BEREICH_GRUPPENNUMMERN)
	add ZL,temp ; temp addieren
	adc ZH,NULL
	ldi temp,'*'
	ST z+,temp
;-------------------------------------------------------------------------------
	; GT (Gruppentyp) auswerten	
	LDS temp,(adr_RDS_GT)
	; Z initialisieren	
	ldi ZL,LOW (RDS_AUSWERTUNG_SPRUNGMARKE)
	ldi ZH,HIGH(RDS_AUSWERTUNG_SPRUNGMARKE)
	add ZL,temp ; temp addieren
	adc ZH,NULL
	; SPRUNG nach Z		
	ijmp
;-------------------------------------------------------------------------------
RDS_AUSWERTUNG_SPRUNGMARKE:
	rjmp RDS_GT_0A
	ret		;rjmp RDS_GT_0B
	ret		;rjmp RDS_GT_1A
	ret		;rjmp RDS_GT_1B
	rjmp RDS_GT_2A
	ret		;rjmp RDS_GT_2B
	ret		;rjmp RDS_GT_3A
	ret		;rjmp RDS_GT_3B
	rjmp RDS_GT_4A
	ret		;rjmp RDS_GT_4B
	ret		;rjmp RDS_GT_5A
	ret		;rjmp RDS_GT_5B
	ret		;rjmp RDS_GT_6A
	ret		;rjmp RDS_GT_6B
	ret		;rjmp RDS_GT_7A
	ret		;rjmp RDS_GT_7B
	ret		;rjmp RDS_GT_8A
	ret		;rjmp RDS_GT_8B
	ret		;rjmp RDS_GT_9A
	ret		;rjmp RDS_GT_9B
	ret		;rjmp RDS_GT_10A
	ret		;rjmp RDS_GT_10B
	ret		;rjmp RDS_GT_11A
	ret		;rjmp RDS_GT_11B
	ret		;rjmp RDS_GT_12A
	ret		;rjmp RDS_GT_12B
	ret		;rjmp RDS_GT_13A
	ret		;rjmp RDS_GT_13B
	ret		;rjmp RDS_GT_14A
	ret		;rjmp RDS_GT_14B
	ret		;rjmp RDS_GT_15A
	ret		;rjmp RDS_GT_15B

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Sendername, TA, Musik/Sprache	(M/S)											
RDS_GT_0A:
	; TA					
	LDS temp,(adr_RDS_BLOCK_BL)
	andi temp,0b00010000	; Bitmuster			
	STS(adr_RDS_TA),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; MS (MUSIK/Sprache)	
	LDS temp,(adr_RDS_BLOCK_BL)
	andi temp,0b00001000	; Bitmuster			
	STS(adr_RDS_MS),temp	; im SRAM ablegen	
;-------------------------------------------------------------------------------
	; AF (Alternativ-Frequenz 1)
	LDS temp,(adr_RDS_BLOCK_CH)
	; Z-initialisieren	
	ldi ZL, LOW (adr_RDS_BEREICH_AF)
	ldi ZH, HIGH(adr_RDS_BEREICH_AF)
	add ZL,temp
	adc ZH,NULL
	ldi temp,1
	ST z+,temp	; im SRAM ablegen	
	; AF (Alternativ-Frequenz 2)
	LDS temp,(adr_RDS_BLOCK_CL)
	; Z-initialisieren	
	ldi ZL, LOW (adr_RDS_BEREICH_AF)
	ldi ZH, HIGH(adr_RDS_BEREICH_AF)
	add ZL,temp
	adc ZH,NULL
	ldi temp,1
	ST z+,temp	; im SRAM ablegen	

;-------------------------------------------------------------------------------
	; Sendername			
	LDS temp1,(adr_RDS_BLOCK_DH)
	LDS temp2,(adr_RDS_BLOCK_DL)
	; Adresse filtern		
	LDS temp,(adr_RDS_BLOCK_BL)
	andi temp,0b00000011
	cpi temp,0
	breq RDS_0A_ADR0
	cpi temp,1
	breq RDS_0A_ADR1
	cpi temp,2
	breq RDS_0A_ADR2
	cpi temp,3
	breq RDS_0A_ADR3
	; SRAM ablegen			
RDS_0A_ADR0:
	STS(adr_RDS_BEREICH_SENDERNAME+0),temp1
	STS(adr_RDS_BEREICH_SENDERNAME+1),temp2
	ret
RDS_0A_ADR1:
	STS(adr_RDS_BEREICH_SENDERNAME+2),temp1
	STS(adr_RDS_BEREICH_SENDERNAME+3),temp2
	ret
RDS_0A_ADR2:
	STS(adr_RDS_BEREICH_SENDERNAME+4),temp1
	STS(adr_RDS_BEREICH_SENDERNAME+5),temp2
	ret
RDS_0A_ADR3:
	STS(adr_RDS_BEREICH_SENDERNAME+6),temp1
	STS(adr_RDS_BEREICH_SENDERNAME+7),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Radiotext																		
RDS_GT_2A:
	; Adresse filtern	
	LDS temp,(adr_RDS_BLOCK_BL)
	andi temp,0b00011111
	; mal 4				
	LSL temp	; x2
	LSL temp	; x2
	; Z-initialisieren	
	ldi ZL, LOW (adr_RDS_BEREICH_RADIOTEXT)
	ldi ZH, HIGH(adr_RDS_BEREICH_RADIOTEXT)
	add ZL,temp
	adc ZH,NULL
	; SRAM speichern	
	LDS temp,(adr_RDS_BLOCK_CH)
	ST z+,temp
	LDS temp,(adr_RDS_BLOCK_CL)
	ST z+,temp
	LDS temp,(adr_RDS_BLOCK_DH)
	ST z+,temp
	LDS temp,(adr_RDS_BLOCK_DL)
	ST z+,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ZEIT + Datum																	
RDS_GT_4A:
	; Offset (in 30 Min)
	LDS temp,(adr_RDS_BLOCK_DL)
	andi temp,0b00111111
	STS(adr_RDS_ZEIT_OFFSET),temp
	; Minuten			
	LDS temp1,(adr_RDS_BLOCK_DH)
	LDS temp ,(adr_RDS_BLOCK_DL)
	LSR temp1	; 6 mal rechts
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	andi temp,0b00111111
	STS(adr_RDS_ZEIT_MM),temp
	; Stunden			
	LDS temp1,(adr_RDS_BLOCK_CL)
	LDS temp ,(adr_RDS_BLOCK_DH)
	LSR temp1	; 4 mal rechts
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	LSR temp1	;
	ROR temp
	andi temp,0b00011111
	STS(adr_RDS_ZEIT_HH),temp
;-------------------------------------------------------------------------------
	; Offsetwert x 30			
	LDS temp1,(adr_RDS_ZEIT_OFFSET)
	mov temp,temp1
	ldi temp9,29	; 29 x addieren
RDS_GT_4A_s:
	add temp1,temp
	dec temp9
	brne RDS_GT_4A_s

	mov temp9,temp1	; Schleife
	LDS temp1,(adr_RDS_ZEIT_mm)	; mm
	LDS temp2,(adr_RDS_ZEIT_hh)	; hh
RDS_GT_4A_SCHLEIFE:
	inc temp1		; mm
	cpi temp1,60
	brsh RDS_GT_4A_HH
	rjmp RDS_GT_4A_w
RDS_GT_4A_HH:
	clr temp1		; mm
	inc temp2		; hh
	cpi temp2,24
	brsh RDS_GT_4A_TAG
	rjmp RDS_GT_4A_w
RDS_GT_4A_TAG:
	clr temp2		; hh
RDS_GT_4A_w:
	dec temp9		; Schleife
	brne RDS_GT_4A_SCHLEIFE
	STS(adr_RDS_ZEIT_mm),temp1	; mm
	STS(adr_RDS_ZEIT_hh),temp2	; hh
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

