; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; MCUCSR																		
;Bit 3  WDRF: Watchdog Reset Flag This bit is set if a Watchdog Reset occurs. The bit is reset by a Power-on Reset, or bywriting a logic zero to the flag.
;Bit 2  BORF: Brown-out Reset Flag This bit is set if a Brown-out Reset occurs. The bit is reset by a Power-on Reset, or bywriting a logic zero to the flag.
;Bit 1  EXTRF: External Reset Flag This bit is set if an External Reset occurs. The bit is reset by a Power-on Reset, or bywriting a logic zero to the flag.
;Bit 0  PORF: Power-on Reset Flag This bit is set if a Power-on Reset occurs. The bit is reset only by writing a logic zero tothe flag.
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
;-------------------------------------------------------------------------------
	; MCUCSR = NULL
	ldi temp,0
	out MCUCSR,temp
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	ret
;-------------------------------------------------------------------------------
NEUSTART_MIT_WDR_FEHLER:
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RS232_INITIALISIEREN:
	ldi temp,TAKT/(BAUD*16)-1  		; Baudrate 								
	out UBRRL,temp
   	ldi temp, (1<<URSEL)|(3<<UCSZ0)	; Frame-Format: 8 Bit					
    out UCSRC, temp
    cbi UCSRB, RXCIE                ; Interrupt bei Empfang	deaktivieren		
    cbi UCSRB, RXEN 				; RX deaktivieren (Empfang)      			
	sbi UCSRB, TXEN  				; TX aktivieren                 		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 	INPUT: temp1														
;																		
;	rcall SENDEN	; INP: TEMP1										
;																		
RS232_DATA_TEMP:
	sbis UCSRA,UDRE  		   	; Warten bis UDR frei             	
	rjmp RS232_DATA_TEMP		; Sprung							
	out UDR, temp				; senden							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RS232_DATA_OUT:
	ldi temp,'*'
	rcall RS232_DATA_TEMP	
	ldi temp,'*'
	rcall RS232_DATA_TEMP

	LDS temp,(adr_RDS_BLOCK_AH)
	rcall RS232_DATA_TEMP
	LDS temp,(adr_RDS_BLOCK_AL)
	rcall RS232_DATA_TEMP

	LDS temp,(adr_RDS_BLOCK_BH)
	rcall RS232_DATA_TEMP
	LDS temp,(adr_RDS_BLOCK_BL)
	rcall RS232_DATA_TEMP

	LDS temp,(adr_RDS_BLOCK_CH)
	rcall RS232_DATA_TEMP
	LDS temp,(adr_RDS_BLOCK_CL)
	rcall RS232_DATA_TEMP

	LDS temp,(adr_RDS_BLOCK_DH)
	rcall RS232_DATA_TEMP
	LDS temp,(adr_RDS_BLOCK_DL)
	rcall RS232_DATA_TEMP

	LDS temp,(adr_RDS_ERROR)
	rcall RS232_DATA_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	ret
;-------------------------------------------------------------------------------
; SCHLEIFE																		
PROGRAMM_CHECK_FEHLER:
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN		
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)		; GELB		
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)			; ROT		

	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	

	rcall wait_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTATUR_INITIALISIERUNG:	
	; auf EINGANG		
	cbi (TASTE_A_DDR),(TASTE_A_PIN_NR)
	cbi (TASTE_B_DDR),(TASTE_B_PIN_NR)
	cbi (TASTE_C_DDR),(TASTE_C_PIN_NR)
	cbi (TASTE_D_DDR),(TASTE_D_PIN_NR)
	; PULL-UP ein		
	sbi (TASTE_A_PORT),(TASTE_A_PIN_NR)
	sbi (TASTE_B_PORT),(TASTE_B_PIN_NR)
	sbi (TASTE_C_PORT),(TASTE_C_PIN_NR)
	sbi (TASTE_D_PORT),(TASTE_D_PIN_NR)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTATUR_ABFRAGE:
	clr temp
	ldi ZL, LOW(10000)
	ldi ZH,HIGH(10000)	
TASTATUR_ABFRAGE_s:
	WDR
	; Taste "A"gedrckt ?		
	sbis (TASTE_A_PIN),(TASTE_A_PIN_NR)				; springe, wenn BIT(PIN) high	
	SBR temp,1
	; Taste "B"gedrckt ?		
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)				; springe, wenn BIT(PIN) high	
	SBR temp,2
	; Taste "C"gedrckt ?		
	sbis (TASTE_C_PIN),(TASTE_C_PIN_NR)				; springe, wenn BIT(PIN) high	
	SBR temp,4
	; Taste "D"gedrckt ?		
	sbis (TASTE_D_PIN),(TASTE_D_PIN_NR)				; springe, wenn BIT(PIN) high	
	SBR temp,8
	; speichern					
	STS(adr_TASTE),temp
	tst temp
	breq TASTATUR_ABFRAGE_w
	; eine Taste wurde gedrckt	
	rcall LCD_CLEAR
	ret
	; Schleife					
TASTATUR_ABFRAGE_w:	
	SBIW ZL,1
	tst ZL
	brne TASTATUR_ABFRAGE_s
	tst ZH
	brne TASTATUR_ABFRAGE_s

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTATUR_AUSWERTUNG:
	LDS temp,(adr_TASTE)
	cpi temp,1
	breq TASTATUR_AUSWERTUNG_1
	cpi temp,2
	breq TASTATUR_AUSWERTUNG_2
	cpi temp,3
	breq TASTATUR_AUSWERTUNG_3
	cpi temp,4
	breq TASTATUR_AUSWERTUNG_4
	cpi temp,8
	breq TASTATUR_AUSWERTUNG_8
	ret
; ------------------------------------------------------------------------------
TASTATUR_AUSWERTUNG_1:
	; SEEK UP		
	rjmp SI4735_FM_SEEK_START_UP
TASTATUR_AUSWERTUNG_2:
	; SEEK DOWN		
	rjmp SI4735_FM_SEEK_START_DOWN
TASTATUR_AUSWERTUNG_3:
	; RESET ber WDR
	rjmp TASTATUR_AUSWERTUNG_3
TASTATUR_AUSWERTUNG_4:
	; MENUE +		
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
	ret
TASTATUR_AUSWERTUNG_8:
	; MENUE -		
	LDS temp,(adr_MENUE)
	dec temp
	tst temp
	; ist negativ ?	
	brpl TASTATUR_AUSWERTUNG_8_w
	clr temp
TASTATUR_AUSWERTUNG_8_w:
	STS(adr_MENUE),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	; Z-initialisieren	
	LDS temp,(adr_MENUE)
	ldi ZL,LOW (MENUE_SPRUNGMARKE)
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	add ZL,temp
	adc ZH,NULL
	; SPRUNG nach Z		
	ijmp
MENUE_SPRUNGMARKE:
	rjmp ANZEIGE_HAUPTMENUE
	rjmp ANZEIGE_RADIOTEXT_SEITE_A
	rjmp ANZEIGE_RADIOTEXT_SEITE_B
	rjmp ANZEIGE_SENDER_INFO
	rjmp ANZEIGE_LISTE_AF_SEITE1
	rjmp ANZEIGE_LISTE_AF_SEITE2
	rjmp ANZEIGE_LISTE_AF_SEITE3
	rjmp ANZEIGE_WARTUNG
	rjmp ANZEIGE_GESENDETE_GRUPPENTYPEN
	rjmp ANZEIGE_VERSION
	; berlauf 			
	STS(adr_MENUE),NULL
	rjmp MENUE
; ##############################################################################
; ##############################################################################
; ##############################################################################


