;												
; RADIO SI4735 AM/FM/RDS fr ATmega8			
; Bernhard.Erfurt@gmx.de						
; 07/2013										
;												
; LCD 2x16										
;												
; LW/AM	(153279 KHz)							
; MW/AM	(5201710 kHz)							
; KW/AM	(2.321.85 MHz)							
; UKW/FM(64108 MHz)							
;												
; Anschlussbelegung PINS						
;												
; PB0 ==> LCD									
; PB1 ==> LCD									
; PB2 ==> LCD									
; PB3 ==> LCD									
; PB4 ==> LCD R/S								
; PB5 ==> LCD E									
; PB6 ==> (Quarz)								
; PB7 ==> (Quarz)								
;												
; PC0 ==> Taste-A								
; PC1 ==> Taste-B								
; PC2 ==> Taste-C								
; PC3 ==> Taste-D								
; PC4 ==> TWI-SDA (grn)						
; PC5 ==> TWI-SCL (gelb)						
;												
; PD0 ==> 										
; PD1 ==> RS232 (OUT)							
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												

; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT							=1000000	; 1 MHz	
; BAUD											
.equ BAUD							=4800
; SENDER bei Programmstart						
.equ SENDER_1=9330		;(9440=94,4) 
; LAUTSTRKEN RX_VOLUME	(0...63 				
.equ LAUTSTAERKE_PROGRAMMSTART		=50
.equ LAUTSTAERKE_TA					=63	 ; TA=Traffic Announcement 	(Verkehrsdurchsage)		
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD
; TASTE "A"									
.equ TASTE_A_PIN_NR					= 0
.equ TASTE_A_PIN					= PINC
.equ TASTE_A_DDR					= DDRC
.equ TASTE_A_PORT					= PORTC
; TASTE "B"									
.equ TASTE_B_PIN_NR					= 1
.equ TASTE_B_PIN					= PINC
.equ TASTE_B_DDR					= DDRC
.equ TASTE_B_PORT					= PORTC
; TASTE "C"									
.equ TASTE_C_PIN_NR					= 2
.equ TASTE_C_PIN					= PINC
.equ TASTE_C_DDR					= DDRC
.equ TASTE_C_PORT					= PORTC
; TASTE "D"									
.equ TASTE_D_PIN_NR					= 3
.equ TASTE_D_PIN					= PINC
.equ TASTE_D_DDR					= DDRC
.equ TASTE_D_PORT					= PORTC
; TWI SLAVE (SI4735)							
.equ TWI_ADRESSE_RADIO				= 17
; TWI MASTER EINSTELLUNGEN						
.equ TWI_BIT_RATE					= 100		; 255	; Bit-Rate							
.equ TWI_PRESCALER					= 0			; 1		; Vorteiler: 0=1 1=4 2=16 3=64		
; FEHLER-CODES									
.equ ERROR_TWI_MT_START				= 10
.equ ERROR_TWI_MT_SLA				= 12
.equ ERROR_TWI_MT_DATA				= 14

.equ ERROR_TWI_MR_START				= 20
.equ ERROR_TWI_MR_SLA				= 21
.equ ERROR_TWI_MR_DATA				= 22
.equ ERROR_TWI_MR_DATAEND			= 23
; FEHLER-CODES									
.equ ERROR_INT_STATUS				= 60
; STATUS-BITS									
.equ STATUS_BIT_CTS 				=128
.equ STATUS_BIT_ERR  				=64
.equ STATUS_BIT_RSQINT 				=8
.equ STATUS_BIT_RDSINT				=4  
.equ STATUS_BIT_STCINT				=1
; LCD (DATA)									
.equ LCD_DATA0_DDR					= DDRB
.equ LCD_DATA1_DDR					= DDRB
.equ LCD_DATA2_DDR					= DDRB
.equ LCD_DATA3_DDR					= DDRB
.equ LCD_DATA0_PORT					= PORTB
.equ LCD_DATA1_PORT					= PORTB
.equ LCD_DATA2_PORT					= PORTB
.equ LCD_DATA3_PORT					= PORTB
.equ LCD_DATA0						= 0
.equ LCD_DATA1						= 1
.equ LCD_DATA2						= 2
.equ LCD_DATA3						= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR						= DDRB
.equ LCD_RS_PORT					= PORTB
.equ LCD_RS							= 4
; LCD_ENABLE									
.equ LCD_E_DDR						= DDRB
.equ LCD_E_PORT						= PORTB
.equ LCD_E							= 5
; Rev. 1.0 4/08 Table 14. Si473x Command												
.equ POWER_UP			= 0x01 ; Power up device and mode selection. 			
.equ GET_REV			= 0x10 ;  Returns revision information on the device.	
.equ POWER_DOWN			= 0x11 ;  Power down device.							
.equ SET_PROPERTY		= 0x12 ;  Sets the value of a property.					
.equ GET_PROPERTY		= 0x13 ;  Retrieves a propertys value.					
.equ GET_INT_STATUS		= 0x14 ;  Read interrupt status bits.					
.equ PATCH_ARGS			= 0x15 ;  Reserved command used for firmware file downloads.
.equ PATCH_DATA			= 0x16 ;  Reserved command used for firmware file downloads.
.equ FM_TUNE_FREQ		= 0x20 ;  Selects the FM tuning frequency.				
.equ FM_SEEK_START		= 0x21 ;  Begins searching for a valid frequency		
.equ FM_TUNE_STATUS		= 0x22 ;  Queries the status of previous FM_TUNE_FREQ or FM_SEEK_START command.
.equ FM_RSQ_STATUS		= 0x23 ;  Queries the status of the Received Signal Quality (RSQ) of the current channel (Si4735 only).
.equ FM_RDS_STATUS		= 0x24 ;  Returns RDS information for current channel and reads an entry from theRDS FIFO (Si4735 only).
.equ AM_TUNE_FREQ		= 0x40 ;  Tunes to a given AM or SW/LW frequency.		
.equ AM_SEEK_START		= 0x41 ;  Begins searching for a valid AM or SW/LW frequency depending on the AM_SEEK_BAND_BOTTOM and AM_SEEK_BAND_TOP settings.
.equ AM_TUNE_STATUS		= 0x42 ;  Queries the status of the already issued AM_TUNE_FREQ or AM_SEEK_START command.
.equ AM_RSQ_STATUS		= 0x43 ;  Queries the status of the RSQ for the current channel.
.equ GPO_CTL			= 0x80 ;  Configures GPO pins.							
.equ GPO_SET			= 0x81 ;  Sets the value of the GPO pins.				

; Rev. 1.0 4/08 Table 15. Si473x Property												
.equ GPO_IEN						= 0x0001 ; Enables interrupt sources. 0x0000
.equ DIGITAL_OUTPUT_FORMAT			= 0x0102 ; Configures the digital output format (Si4735 only). 0x0000
.equ DIGITAL_OUTPUT_SAMPLE_RATE		= 0x0104 ; Configures the digital output sample rate in 100 Hz steps. The digital output sample rate is disabled by default (Si4735 only). 0x0000
.equ REFCLK_FREQ 					= 0x0201 ; Sets frequency of reference clock in Hz. The range is 31130 to 34406 Hz, or 0 to disable the AFC. Default is 32768 Hz. 0x8000
.equ REFCLK_PRESCALE				= 0x0202 ; Sets the prescaler value for RCLK input. 0x0001
.equ FM_DEEMPHASIS					= 0x1100 ; Sets de-emphasis time constant. Default is 75 us. 0x0002
.equ FM_BLEND_STEREO_THRESHOLD 		= 0x1105 ; Sets RSSI threshold for stereo blend (full stereo above threshold,blend below threshold). To force stereo set this to 0. To force mono set this to 127. Default value is 49 dBuV. 0x0031
.equ FM_BLEND_MONO_THRESHOLD		= 0x1106 ; Sets RSSI threshold for mono blend (full mono below threshold, blend above threshold). To force stereo set this to 0. To force mono set this to 127. Default value is 30 dBuV.0x001E 
.equ FM_MAX_TUNE_ERROR 				= 0x1108 ; Sets the maximum freq error allowed before setting the AFC rail (AFCRL) indicator. Default value is 30 kHz. 0x001E 
.equ FM_RSQ_INT_SOURCE 				= 0x1200 ; Configures interrupt related to RSQ metrics. 0x0000
.equ FM_RSQ_SNR_HI_THRESHOLD		= 0x1201 ; Sets high threshold for SNR interrupt. 0x007F
.equ FM_RSQ_SNR_LO_THRESHOLD		= 0x1202 ; Sets low threshold for SNR interrupt. 0x0000
.equ FM_RSQ_RSSI_HI_THRESHOLD		= 0x1203 ; Sets high threshold for RSSI interrupt. 0x007F
.equ FM_RSQ_RSSI_LO_THRESHOLD		= 0x1204 ; Sets low threshold for RSSI interrupt. 0x0000
.equ FM_RSQ_BLEND_THRESHOLD			= 0x1207 ; Sets the blend threshold for blend interrupt when boundary is crossed. 0x0081 
.equ FM_SOFT_MUTE_MAX_ATTENUATION	= 0x1302 ; Sets maximum attenuation during soft mute (dB). Set to 0 to disable soft mute. Default is 16 dB. 0x0010
.equ FM_SOFT_MUTE_SNR_THRESHOLD 	= 0x1303 ; Sets SNR threshold to engage soft mute. Default is 4 dB. 0x0004
.equ FM_SEEK_BAND_BOTTOM			= 0x1400 ; Sets the bottom of the FM band for seek. Default is 8750. 0x222E
.equ FM_SEEK_BAND_TOP 				= 0x1401 ; Sets the top of the FM band for seek. Default is 10790. 0x2A26
.equ FM_SEEK_FREQ_SPACING			= 0x1402 ; Selects frequency spacing for FM seek. 0x000A
.equ FM_SEEK_TUNE_SNR_THRESHOLD		= 0x1403 ; Sets the SNR threshold for a valid FM Seek/Tune. Default value is 3 dB. 0x0003
.equ FM_SEEK_TUNE_RSSI_THRESHOLD	= 0x1404 ; Sets the RSSI threshold for a valid FM Seek/Tune. Default value is 20 dBuV. 0x0014
.equ FM_RDS_INT_SOURCE				= 0x1500 ; Configures RDS interrupt behavior. 0x0000
.equ FM_RDS_INT_FIFO_COUNT			= 0x1501 ; Sets the minimum number of RDS groups stored in the receive RDS FIFO required before RDS RECV is set. 0x0000
.equ FM_RDS_CONFIG 					= 0x1502 ; Configures RDS setting. 0x0000
.equ FM_BLEND_RSSI_STEREO_THRESHOLD	= 0x1800 ; Sets RSSI threshold for stereo blend. (Full stereo above threshold, blend below threshold.) To force stereo, set this to 0. To force mono, set this to 127. Default value is 49 dBV. (0x0031)
.equ FM_BLEND_RSSI_MONO_THRESHOLD   = 0x1801 ; Sets RSSI threshold for mono blend (Full mono below threshold, blend above threshold). To force stereo, set this to 0. To force mono, set this to 127. Default value is 30 dBV. (0x001E)

.equ FM_BLEND_RSSI_ATTACK_RATE		= 0x1802
.equ FM_BLEND_RSSI_RELEASE_RATE		= 0x1803
.equ FM_BLEND_SNR_STEREO_THRESHOLD  = 0x1804
.equ FM_BLEND_SNR_MONO_THRESHOLD	= 0x1805
.equ FM_BLEND_SNR_ATTACK_RATE		= 0x1806
.equ FM_BLEND_SNR_RELEASE_RATE		= 0x1807
.equ FM_BLEND_MULTIPATH_STEREO_THRESHOLD= 0x1808

.equ AM_DEEMPHASIS 					= 0x3100 ; Sets de-emphasis time constant. Can be set to 50 us. Deemphasis is disabled by default. 0x0000
.equ AM_CHANNEL_FILTER				= 0x3102 ; Selects the bandwidth of the channel filter for AM/SW/LW reception. The choices are 6, 4, 3, 2, or 1 (kHz). The default bandwidth is 2 kHz. 0x0003
.equ AM_RSQ_INTERRUPTS				= 0x3200 ; Configures interrupt related to RSQ metrics. All interrupts are disabled by default. 0x0000
.equ AM_RSQ_SNR_HIGH_THRESHOLD		= 0x3201 ; Sets high threshold for SNR interrupt. The default is 0 dB. 0x007F
.equ AM_RSQ_SNR_LOW_THRESHOLD		= 0x3202 ; Sets low threshold for SNR interrupt. The default is 0 dB. 0x0000	
.equ AM_RSQ_RSSI_HIGH_THRESHOLD		= 0x3203 ; Sets high threshold for RSSI interrupt. The default is 0 dB. 0x007F
.equ AM_RSQ_RSSI_LOW_THRESHOLD		= 0x3204 ; Sets low threshold for RSSI interrupt. The default is 0 dB. 0x0000	
.equ AM_SOFT_MUTE_RATE				= 0x3300 ; Sets the rate of attack when entering or leaving soft mute. The default is 278 dB/s. 0x0040
.equ AM_SOFT_MUTE_SLOPE				= 0x3301 ; Sets the AM/SW/LW soft mute slope. The bigger the number, the higher the max attenuation level. Default value is a slope of 2.0x0002
.equ AM_SOFT_MUTE_MAX_ATTENUATION	= 0x3302 ; Sets maximum attenuation during soft mute (dB). Set to 0 to disable soft mute. Default is 16 dB. 0x0010 
.equ AM_SOFT_MUTE_SNR_THRESHOLD		= 0x3303 ; Sets SNR threshold to engage soft mute. Default is 10 dB. 0x000A		
.equ AM_SEEK_BAND_BOTTOM			= 0x3400 ; Sets the bottom of the AM/SW/LW band for seek. Default is 520. 0x0208	
.equ AM_SEEK_BAND_TOP				= 0x3401 ; Sets the top of the AM/SW/LW band for seek. Default is 1720. 0x06AE	
.equ AM_SEEK_FREQ_SPACING			= 0x3402 ; Selects frequency spacing for AM/SW/LW seek. Default is 10 kHz spacing. 0x000A
.equ AM_SEEK_SNR_THRESHOLD			= 0x3403 ; Sets the SNR threshold for a valid AM/SW/LW Seek/Tune. If the value is zero then SNR threshold is not considered when doing a seek. Default value is 5 dB. 0x0005
.equ AM_SEEK_RSSI_THRESHOLD			= 0x3404 ; Sets the RSSI threshold for a valid AM/SW/LW Seek/Tune. If the value is zero then RSSI threshold is not considered when doing a seek. Default value is 25 dBuV.0x0019
.equ RX_VOLUME						= 0x4000 ; Sets the output volume. 0x003F										
.equ RX_HARD_MUTE					= 0x4001 ; Mutes the audio output. L and R audio outputs may be muted independently in FM mode. 0x0000


; REGISTER										


.def FEHLER_CODE_TWI 	= R6

.def NULL 	= R12
.def EINS 	= R14
.def VOLL	= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=SRAM_START+0	; 0x0060 START Adresse (ATmega8)	

.equ adr_TASTE						=SRAM_START+2	; TASTE								

.equ adr_MENUE						=SRAM_START+3	; MENUE								

.equ adr_ERROR_CODE					=SRAM_START+4	; ERROR-CODE						

.equ adr_FREQUENZ_SOLL_L			=SRAM_START+10 	; Frequenz "SOLL"					
.equ adr_FREQUENZ_SOLL_H			=SRAM_START+11

.equ adr_FREQUENZ_IST_L				=SRAM_START+12	; Frequenz "IST"					
.equ adr_FREQUENZ_IST_H				=SRAM_START+13

.equ adr_PILOT						=SRAM_START+40 	; Pilot Indicator 0=Mono 1=Stereo					
.equ adr_STBLEND					=SRAM_START+41  ; Stereo Blend Indicator. Indicates amount of stereo blend in% (100 = full stereo, 0 = full mono).
.equ adr_RSSI   					=SRAM_START+42 	; Received Signal Strength Indicator. Contains the current receive signal strength (0127 dBV).				
.equ adr_SNR    					=SRAM_START+43	; SNR. Contains the current SNR metric (0127 dB).	
.equ adr_MULT						=SRAM_START+44	; Multipath	

.equ adr_PROPERTY_L					=SRAM_START+60
.equ adr_PROPERTY_H					=SRAM_START+61
.equ adr_PROPERTY_VALUE_L			=SRAM_START+62
.equ adr_PROPERTY_VALUE_H			=SRAM_START+63

.equ adr_STATUS						=SRAM_START+100
.equ adr_RESP_01					=SRAM_START+101
.equ adr_RESP_02					=SRAM_START+102
.equ adr_RESP_03					=SRAM_START+103
.equ adr_RESP_04					=SRAM_START+104
.equ adr_RESP_05					=SRAM_START+105
.equ adr_RESP_06					=SRAM_START+106
.equ adr_RESP_07					=SRAM_START+107
.equ adr_RESP_08					=SRAM_START+108
.equ adr_RESP_09					=SRAM_START+109
.equ adr_RESP_10					=SRAM_START+110
.equ adr_RESP_11					=SRAM_START+111
.equ adr_RESP_12					=SRAM_START+112
.equ adr_RESP_13					=SRAM_START+113
.equ adr_RESP_14					=SRAM_START+114
.equ adr_RESP_15					=SRAM_START+115
.equ adr_RESP_16					=SRAM_START+116
.equ adr_RESP_17					=SRAM_START+117
.equ adr_RESP_18					=SRAM_START+118
.equ adr_RESP_19					=SRAM_START+119
.equ adr_RESP_20					=SRAM_START+120



.equ adr_RDS_BLOCK_AH				=SRAM_START+160
.equ adr_RDS_BLOCK_AL				=SRAM_START+161
.equ adr_RDS_BLOCK_BH				=SRAM_START+162
.equ adr_RDS_BLOCK_BL				=SRAM_START+163
.equ adr_RDS_BLOCK_CH				=SRAM_START+164
.equ adr_RDS_BLOCK_CL				=SRAM_START+165
.equ adr_RDS_BLOCK_DH				=SRAM_START+166
.equ adr_RDS_BLOCK_DL				=SRAM_START+167

.equ adr_RDS_PI_L					=SRAM_START+180	; PI										
.equ adr_RDS_PI_H					=SRAM_START+181	; PI										
.equ adr_RDS_GT						=SRAM_START+182	; Gruppentyp								
.equ adr_RDS_PTY					=SRAM_START+183 ; PTY										
.equ adr_RDS_TP						=SRAM_START+184	; Traffic Programm 		(Verkehsfunk)		
.equ adr_RDS_TA						=SRAM_START+185 ; Traffic Announcement 	(Verkehrsdurchsage)	
.equ adr_RDS_MS						=SRAM_START+186 ; Musik / Sprache							
.equ adr_RDS_ERROR					=SRAM_START+187	; RDS-Error									
.equ adr_RDS_ZEIT_HH				=SRAM_START+188	; RDS-ZEIT									
.equ adr_RDS_ZEIT_MM				=SRAM_START+189 ; RDS-ZEIT									
.equ adr_RDS_ZEIT_OFFSET			=SRAM_START+190 ; RDS-ZEIT (Offset)							
.equ adr_RDS_AF_ZEIGER				=SRAM_START+191 ; Zeiger fr AF Darstellung					

.equ adr_RDS_BEREICH_SENDERNAME		=SRAM_START+200	;   8 Bytes fr Sendername					
.equ adr_RDS_BEREICH_RADIOTEXT		=SRAM_START+210	; 128 Bytes	fr Radiotext					
.equ adr_RDS_BEREICH_GRUPPENNUMMERN =SRAM_START+400	;  32 Bytes	fr empfangene Gruppennummern)	
.equ adr_RDS_BEREICH_AF 			=SRAM_START+450	;  256 Bytes fr Alternativfrequenzen		



.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	



.cseg					;Beginn eines Code-Segmentes							
.org 0					;Startadresse=0											

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
	rcall SRAM_CLEAR
; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; 
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; 
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	; 
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000	; 
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; 
	out PORTD, temp				
; LED-INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; SENDER-1			
	ldi temp1, LOW(SENDER_1)
	ldi temp2,HIGH(SENDER_1)
	STS(adr_FREQUENZ_SOLL_L),temp1
	STS(adr_FREQUENZ_SOLL_H),temp2
; LCD-INITIALISIERUNG								
	rcall LCD_INITIALISIERUNG
; TASTATUR_INITIALISIERUNG							
	rcall TASTATUR_INITIALISIERUNG
; TWI_INI											
	rcall TWI_INI
; RS232_INITIALISIEREN								
	rcall RS232_INITIALISIEREN
; 	PROGRAMM_CHECK									
	rcall PROGRAMM_CHECK
; Interrupts freigeben								
	sei
;-------------------------------------------------------------------------------
	rcall ANZEIGE_BEGRUESSUNG_4_ZEILEN	
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	rcall SI4735_POWER_DOWN
	rcall SI4735_POWER_UP_FM
	rcall SI4735_FM_RDS_INITIALISIERUNG
	rcall SI4735_FM_TUNE_FREQ
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	

; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
	rcall TASTATUR_ABFRAGE
	rcall TASTATUR_AUSWERTUNG
	rcall SI4735_FM_TUNE_STATUS
	rcall SI4735_FM_RSQ_STATUS
	rcall SI4735_FM_RDS_STATUS
	rcall SI4735_FM_LAUTSTAERKE_TA
	rcall MENUE

	rcall PROGRAMM_CHECK
	rcall ANZEIGE_ERROR
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "RADIO_LCD.asm"				; LCD allgemein					
.include "RADIO_LCD_ini.asm"			; LCD  Initialisierung 2/4x16/20
.include "RADIO_LCD_KURZ.asm"			; LCD
.include "RADIO_SONSTIGES.asm"			; sonstiges						
.include "RADIO_TWI.asm"
.include "RADIO_SI4735_ALLG.asm"
.include "RADIO_SI4735_FM.asm"
.include "RADIO_SI4735_RDS.asm"
.include "RADIO_SI4735_AM.asm"
.include "RADIO_WAIT_01MHZ.asm"		;  1 MHz						
;.include "RADIO_WAIT_08MHZ.asm"		;  8 MHz						
;.include "RADIO_WAIT_16MHZ.asm"		; 16 MHz						

TEXT_BEGRUESSUNG_1:
.db "RADIO",0
TEXT_BEGRUESSUNG_2:
.db "SI4735 ",0
TEXT_BEGRUESSUNG_3:
.db "ATmega8 - 1MHz ",0
TEXT_BEGRUESSUNG_4:
.db "07/2013",0

TEXT_PTY_00: 
.db "kein PTY",0
TEXT_PTY_01: 
.db "Nachrichten",0 
TEXT_PTY_02: 
.db "Aktuelles",0 
TEXT_PTY_03: 
.db "Information",0 
TEXT_PTY_04: 
.db "Sport",0 
TEXT_PTY_05: 
.db "Bildung",0 
TEXT_PTY_06: 
.db "Hrspiel",0 
TEXT_PTY_07: 
.db "Kultur",0 
TEXT_PTY_08: 
.db "Wissenschaft",0 
TEXT_PTY_09: 
.db "Unterhaltung (Wort)",0 
TEXT_PTY_10: 
.db "Popmusik",0
TEXT_PTY_11: 
.db "Rockmusik",0 
TEXT_PTY_12: 
.db "Unterhaltungsmusik",0 
TEXT_PTY_13: 
.db "Leichte Klassik",0 
TEXT_PTY_14: 
.db "Ernste Klassik",0 
TEXT_PTY_15: 
.db "Andere Musik",0 
TEXT_PTY_16: 
.db "Wetter",0
TEXT_PTY_17: 
.db "Finanzen",0
TEXT_PTY_18: 
.db "Kinderprogramm",0
TEXT_PTY_19: 
.db "Gesellschaftliches",0
TEXT_PTY_20: 
.db "Religion",0
TEXT_PTY_21: 
.db "Telefonieren",0
TEXT_PTY_22: 
.db "Reisen",0
TEXT_PTY_23: 
.db "Freizeit",0
TEXT_PTY_24: 
.db "Jazzmusik",0
TEXT_PTY_25: 
.db "Countrymusik",0
TEXT_PTY_26: 
.db "Nationale Musik",0
TEXT_PTY_27: 
.db "Oldies",0
TEXT_PTY_28: 
.db "Volksmusik",0
TEXT_PTY_29: 
.db "Dokumentationen",0
TEXT_PTY_30: 
.db "Testalarm",0
TEXT_PTY_31: 
.db "Alarm",0


TEXT_PI_ZIFFER3_0: 
.db "Baden-Wrttemberg",0
TEXT_PI_ZIFFER3_1: 
.db "Bayern",0
TEXT_PI_ZIFFER3_2: 
.db "Berlin",0
TEXT_PI_ZIFFER3_3: 
.db "Brandenburg",0
TEXT_PI_ZIFFER3_4: 
.db "Bremen",0 
TEXT_PI_ZIFFER3_5: 
.db "Hamburg",0
TEXT_PI_ZIFFER3_6: 
.db "Hessen",0
TEXT_PI_ZIFFER3_7: 
.db "Mecklenburg-Vorpommern",0
TEXT_PI_ZIFFER3_8: 
.db "Niedersachsen",0
TEXT_PI_ZIFFER3_9: 
.db "Nordrhein-Westfalen",0
TEXT_PI_ZIFFER3_A: 
.db "Rheinland-Pfalz",0
TEXT_PI_ZIFFER3_B: 
.db "Saarland",0
TEXT_PI_ZIFFER3_C: 
.db "Sachsen privat",0
TEXT_PI_ZIFFER3_D: 
.db "Sachsen-Anhalt",0
TEXT_PI_ZIFFER3_E: 
.db "Schleswig-Holstein",0
TEXT_PI_ZIFFER3_F: 
.db "Thringen",0
